package com.tomlost.ScrollingPanel;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.tomlost.ScrollingPanel", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "com.tomlost.ScrollingPanel", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.PanelWrapper _mainpanel = null;
public anywheresoftware.b4a.objects.PanelWrapper _overpanel = null;
public static int[] _startx = null;
public static int[] _starty = null;
public static int[] _leftmargin = null;
public static int[] _w = null;
public static long _time0 = 0L;
public anywheresoftware.b4a.objects.AnimationWrapper[] _sdl = null;
public anywheresoftware.b4a.objects.AnimationWrapper[] _sdr = null;
public static int _picw = 0;
public static int _pich = 0;
public static int _picc = 0;
public anywheresoftware.b4a.objects.PanelWrapper[] _picpanel = null;
public anywheresoftware.b4a.objects.PanelWrapper _tmainpanel = null;
public anywheresoftware.b4a.objects.PanelWrapper _toverpanel = null;
public anywheresoftware.b4a.objects.PanelWrapper[] _picpanel2 = null;
public anywheresoftware.b4a.objects.PanelWrapper _mainpanel2 = null;
public anywheresoftware.b4a.objects.PanelWrapper _overpanel2 = null;
public anywheresoftware.b4a.objects.PanelWrapper[] _cmainpanel = null;
public anywheresoftware.b4a.objects.PanelWrapper[] _line = null;
public static int _currentslide = 0;
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _b = null;
int _i = 0;
 //BA.debugLineNum = 31;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 32;BA.debugLine="Dim b As Bitmap";
_b = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 35;BA.debugLine="picW=50*2:picH=67*2:picC=20";
_picw = (int)(50*2);
 //BA.debugLineNum = 35;BA.debugLine="picW=50*2:picH=67*2:picC=20";
_pich = (int)(67*2);
 //BA.debugLineNum = 35;BA.debugLine="picW=50*2:picH=67*2:picC=20";
_picc = (int)(20);
 //BA.debugLineNum = 36;BA.debugLine="mainPanel.Initialize(\"mainPanel\")";
mostCurrent._mainpanel.Initialize(mostCurrent.activityBA,"mainPanel");
 //BA.debugLineNum = 37;BA.debugLine="overPanel.Initialize(\"TouchListener\")";
mostCurrent._overpanel.Initialize(mostCurrent.activityBA,"TouchListener");
 //BA.debugLineNum = 38;BA.debugLine="For i=0 To 19";
{
final double step19 = 1;
final double limit19 = (int)(19);
for (_i = (int)(0); (step19 > 0 && _i <= limit19) || (step19 < 0 && _i >= limit19); _i += step19) {
 //BA.debugLineNum = 39;BA.debugLine="picPanel(i).Initialize(\"picPanel\")";
mostCurrent._picpanel[_i].Initialize(mostCurrent.activityBA,"picPanel");
 //BA.debugLineNum = 40;BA.debugLine="b=LoadBitmap(File.DirAssets,i & \".jpg\")";
_b = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),BA.NumberToString(_i)+".jpg");
 //BA.debugLineNum = 41;BA.debugLine="picPanel(i).SetBackgroundImage(b)";
mostCurrent._picpanel[_i].SetBackgroundImage((android.graphics.Bitmap)(_b.getObject()));
 //BA.debugLineNum = 42;BA.debugLine="mainPanel.AddView(picPanel(i),i*(picw+1),0,picw,picH)";
mostCurrent._mainpanel.AddView((android.view.View)(mostCurrent._picpanel[_i].getObject()),(int)(_i*(_picw+1)),(int)(0),_picw,_pich);
 }
};
 //BA.debugLineNum = 44;BA.debugLine="Activity.AddView(mainPanel,0,0,picC*(picW+1),picH)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._mainpanel.getObject()),(int)(0),(int)(0),(int)(_picc*(_picw+1)),_pich);
 //BA.debugLineNum = 45;BA.debugLine="Activity.AddView(overPanel,0,0,100%x,picH)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._overpanel.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),_pich);
 //BA.debugLineNum = 48;BA.debugLine="Line(1).Initialize(0)";
mostCurrent._line[(int)(1)].Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 //BA.debugLineNum = 49;BA.debugLine="Line(1).Color=Colors.Red";
mostCurrent._line[(int)(1)].setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 50;BA.debugLine="mainPanel.AddView(Line(1),0,0,picw,0) 'height:0 unvisible when initial";
mostCurrent._mainpanel.AddView((android.view.View)(mostCurrent._line[(int)(1)].getObject()),(int)(0),(int)(0),_picw,(int)(0));
 //BA.debugLineNum = 52;BA.debugLine="CreateSlider(mainPanel,overPanel,1000,1,picW+1)";
_createslider(mostCurrent._mainpanel,mostCurrent._overpanel,(int)(1000),(int)(1),(int)(_picw+1));
 //BA.debugLineNum = 56;BA.debugLine="mainPanel2.Initialize(\"mainPanel2\")";
mostCurrent._mainpanel2.Initialize(mostCurrent.activityBA,"mainPanel2");
 //BA.debugLineNum = 57;BA.debugLine="overPanel2.Initialize(\"TouchListener\")";
mostCurrent._overpanel2.Initialize(mostCurrent.activityBA,"TouchListener");
 //BA.debugLineNum = 58;BA.debugLine="For i=0 To 19";
{
final double step33 = 1;
final double limit33 = (int)(19);
for (_i = (int)(0); (step33 > 0 && _i <= limit33) || (step33 < 0 && _i >= limit33); _i += step33) {
 //BA.debugLineNum = 59;BA.debugLine="picPanel2(i).Initialize(\"picPanel2\")";
mostCurrent._picpanel2[_i].Initialize(mostCurrent.activityBA,"picPanel2");
 //BA.debugLineNum = 60;BA.debugLine="b=LoadBitmap(File.DirAssets,i & \".jpg\")";
_b = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),BA.NumberToString(_i)+".jpg");
 //BA.debugLineNum = 61;BA.debugLine="picPanel2(i).SetBackgroundImage(b)";
mostCurrent._picpanel2[_i].SetBackgroundImage((android.graphics.Bitmap)(_b.getObject()));
 //BA.debugLineNum = 62;BA.debugLine="mainPanel2.AddView(picPanel2(i),i*(picw+1),0,picw,picH)";
mostCurrent._mainpanel2.AddView((android.view.View)(mostCurrent._picpanel2[_i].getObject()),(int)(_i*(_picw+1)),(int)(0),_picw,_pich);
 }
};
 //BA.debugLineNum = 64;BA.debugLine="Activity.AddView(mainPanel2,0,200,picC*(picW+1),picH)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._mainpanel2.getObject()),(int)(0),(int)(200),(int)(_picc*(_picw+1)),_pich);
 //BA.debugLineNum = 65;BA.debugLine="Activity.AddView(overPanel2,0,200,100%x,picH)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._overpanel2.getObject()),(int)(0),(int)(200),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),_pich);
 //BA.debugLineNum = 67;BA.debugLine="Line(2).Initialize(0)";
mostCurrent._line[(int)(2)].Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 //BA.debugLineNum = 68;BA.debugLine="Line(2).Color=Colors.Red";
mostCurrent._line[(int)(2)].setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 69;BA.debugLine="mainPanel2.AddView(Line(2),0,0,picw,0) 'height:0 unvisible when initial";
mostCurrent._mainpanel2.AddView((android.view.View)(mostCurrent._line[(int)(2)].getObject()),(int)(0),(int)(0),_picw,(int)(0));
 //BA.debugLineNum = 71;BA.debugLine="CreateSlider(mainPanel2,overPanel2,1000,2,picw+1)";
_createslider(mostCurrent._mainpanel2,mostCurrent._overpanel2,(int)(1000),(int)(2),(int)(_picw+1));
 //BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 78;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 74;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static String  _choosed(int _x) throws Exception{
String _i = "";
 //BA.debugLineNum = 156;BA.debugLine="Sub Choosed(x As Int)";
 //BA.debugLineNum = 157;BA.debugLine="i=Floor((-leftmargin(currentSlide)+x)/W(currentSlide))";
_i = BA.NumberToString(anywheresoftware.b4a.keywords.Common.Floor((-_leftmargin[_currentslide]+_x)/(double)_w[_currentslide]));
 //BA.debugLineNum = 158;BA.debugLine="Line(currentSlide).Left = i*w(currentSlide)";
mostCurrent._line[_currentslide].setLeft((int)((double)(Double.parseDouble(_i))*_w[_currentslide]));
 //BA.debugLineNum = 159;BA.debugLine="Line(currentSlide).Height=10";
mostCurrent._line[_currentslide].setHeight((int)(10));
 //BA.debugLineNum = 160;BA.debugLine="Line(currentSlide).Color = Colors.Red";
mostCurrent._line[_currentslide].setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 161;BA.debugLine="Line(currentSlide).BringToFront";
mostCurrent._line[_currentslide].BringToFront();
 //BA.debugLineNum = 164;BA.debugLine="End Sub";
return "";
}
public static String  _createslider(anywheresoftware.b4a.objects.PanelWrapper _pmainpanel,anywheresoftware.b4a.objects.PanelWrapper _poverpanel,int _slidingduration,int _slidenumber,int _pwidth) throws Exception{
 //BA.debugLineNum = 85;BA.debugLine="Sub CreateSlider(pMainPanel As Panel,pOverPanel As Panel,SlidingDuration As Int,SlideNumber As Int,pWidth As Int)";
 //BA.debugLineNum = 87;BA.debugLine="cMainPanel(SlideNumber)= pMainPanel";
mostCurrent._cmainpanel[_slidenumber] = _pmainpanel;
 //BA.debugLineNum = 88;BA.debugLine="pOverPanel.Tag=SlideNumber";
_poverpanel.setTag((Object)(_slidenumber));
 //BA.debugLineNum = 90;BA.debugLine="sdL(SlideNumber).InitializeTranslate(\"sdL\",0,0,-poverPanel.Width,0):	sdL(SlideNumber).Duration=SlidingDuration";
mostCurrent._sdl[_slidenumber].InitializeTranslate(mostCurrent.activityBA,"sdL",(float)(0),(float)(0),(float)(-_poverpanel.getWidth()),(float)(0));
 //BA.debugLineNum = 90;BA.debugLine="sdL(SlideNumber).InitializeTranslate(\"sdL\",0,0,-poverPanel.Width,0):	sdL(SlideNumber).Duration=SlidingDuration";
mostCurrent._sdl[_slidenumber].setDuration((long)(_slidingduration));
 //BA.debugLineNum = 91;BA.debugLine="sdR(SlideNumber).InitializeTranslate(\"sdR\",0,0, poverPanel.Width,0):	sdR(SlideNumber).Duration=SlidingDuration";
mostCurrent._sdr[_slidenumber].InitializeTranslate(mostCurrent.activityBA,"sdR",(float)(0),(float)(0),(float)(_poverpanel.getWidth()),(float)(0));
 //BA.debugLineNum = 91;BA.debugLine="sdR(SlideNumber).InitializeTranslate(\"sdR\",0,0, poverPanel.Width,0):	sdR(SlideNumber).Duration=SlidingDuration";
mostCurrent._sdr[_slidenumber].setDuration((long)(_slidingduration));
 //BA.debugLineNum = 92;BA.debugLine="leftmargin(SlideNumber)=0:StartX(SlideNumber)=0";
_leftmargin[_slidenumber] = (int)(0);
 //BA.debugLineNum = 92;BA.debugLine="leftmargin(SlideNumber)=0:StartX(SlideNumber)=0";
_startx[_slidenumber] = (int)(0);
 //BA.debugLineNum = 93;BA.debugLine="W(SlideNumber)=pWidth";
_w[_slidenumber] = _pwidth;
 //BA.debugLineNum = 94;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 9;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 12;BA.debugLine="Dim mainPanel As Panel,	overPanel As Panel";
mostCurrent._mainpanel = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._overpanel = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 13;BA.debugLine="Dim startX(10),startY(10) ,leftmargin(10),W(10) As Int";
_startx = new int[(int)(10)];
;
_starty = new int[(int)(10)];
;
_leftmargin = new int[(int)(10)];
;
_w = new int[(int)(10)];
;
 //BA.debugLineNum = 14;BA.debugLine="Dim time0 As Long";
_time0 = 0L;
 //BA.debugLineNum = 15;BA.debugLine="Dim sdL(10),sdR(10) As Animation";
mostCurrent._sdl = new anywheresoftware.b4a.objects.AnimationWrapper[(int)(10)];
{
int d0 = mostCurrent._sdl.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._sdl[i0] = new anywheresoftware.b4a.objects.AnimationWrapper();
}
}
;
mostCurrent._sdr = new anywheresoftware.b4a.objects.AnimationWrapper[(int)(10)];
{
int d0 = mostCurrent._sdr.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._sdr[i0] = new anywheresoftware.b4a.objects.AnimationWrapper();
}
}
;
 //BA.debugLineNum = 17;BA.debugLine="Dim picW,picH,picC As Int";
_picw = 0;
_pich = 0;
_picc = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim picPanel(20),tMainPanel,tOverPanel As Panel";
mostCurrent._picpanel = new anywheresoftware.b4a.objects.PanelWrapper[(int)(20)];
{
int d0 = mostCurrent._picpanel.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._picpanel[i0] = new anywheresoftware.b4a.objects.PanelWrapper();
}
}
;
mostCurrent._tmainpanel = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._toverpanel = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim picPanel2(20),mainPanel2 , overPanel2 As Panel";
mostCurrent._picpanel2 = new anywheresoftware.b4a.objects.PanelWrapper[(int)(20)];
{
int d0 = mostCurrent._picpanel2.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._picpanel2[i0] = new anywheresoftware.b4a.objects.PanelWrapper();
}
}
;
mostCurrent._mainpanel2 = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._overpanel2 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim cMainPanel(10),Line(10) As Panel,currentSlide As Int";
mostCurrent._cmainpanel = new anywheresoftware.b4a.objects.PanelWrapper[(int)(10)];
{
int d0 = mostCurrent._cmainpanel.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._cmainpanel[i0] = new anywheresoftware.b4a.objects.PanelWrapper();
}
}
;
mostCurrent._line = new anywheresoftware.b4a.objects.PanelWrapper[(int)(10)];
{
int d0 = mostCurrent._line.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._line[i0] = new anywheresoftware.b4a.objects.PanelWrapper();
}
}
;
_currentslide = 0;
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _movepanel(float _x) throws Exception{
 //BA.debugLineNum = 141;BA.debugLine="Sub MovePanel(x As Float)";
 //BA.debugLineNum = 142;BA.debugLine="tMainPanel.Left= leftmargin(currentslide) + x-startX(currentslide)";
mostCurrent._tmainpanel.setLeft((int)(_leftmargin[_currentslide]+_x-_startx[_currentslide]));
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 3;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 7;BA.debugLine="End Sub";
return "";
}
public static String  _sdl_animationend() throws Exception{
 //BA.debugLineNum = 144;BA.debugLine="Sub sdL_AnimationEnd";
 //BA.debugLineNum = 145;BA.debugLine="leftmargin(currentslide) = leftmargin(currentslide) - tOverPanel.Width";
_leftmargin[_currentslide] = (int)(_leftmargin[_currentslide]-mostCurrent._toverpanel.getWidth());
 //BA.debugLineNum = 146;BA.debugLine="if leftmargin(currentslide)<= -tMainPanel.Width+tOverPanel.Width Then";
if (_leftmargin[_currentslide]<=-mostCurrent._tmainpanel.getWidth()+mostCurrent._toverpanel.getWidth()) { 
 //BA.debugLineNum = 147;BA.debugLine="leftmargin(currentslide) = -tMainPanel.Width+tOverPanel.Width";
_leftmargin[_currentslide] = (int)(-mostCurrent._tmainpanel.getWidth()+mostCurrent._toverpanel.getWidth());
 };
 //BA.debugLineNum = 149;BA.debugLine="tmainPanel.Left= leftmargin(currentslide)";
mostCurrent._tmainpanel.setLeft(_leftmargin[_currentslide]);
 //BA.debugLineNum = 150;BA.debugLine="End Sub";
return "";
}
public static String  _sdr_animationend() throws Exception{
 //BA.debugLineNum = 151;BA.debugLine="Sub sdR_AnimationEnd";
 //BA.debugLineNum = 152;BA.debugLine="leftmargin(currentslide) = leftmargin(currentslide) + toverpanel.Width";
_leftmargin[_currentslide] = (int)(_leftmargin[_currentslide]+mostCurrent._toverpanel.getWidth());
 //BA.debugLineNum = 153;BA.debugLine="if leftmargin(currentslide)>=0 Then leftmargin(currentslide)=0";
if (_leftmargin[_currentslide]>=0) { 
_leftmargin[_currentslide] = (int)(0);};
 //BA.debugLineNum = 154;BA.debugLine="tmainPanel.Left= leftmargin(currentslide)";
mostCurrent._tmainpanel.setLeft(_leftmargin[_currentslide]);
 //BA.debugLineNum = 155;BA.debugLine="End Sub";
return "";
}
public static boolean  _touchlistener_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 96;BA.debugLine="Sub TouchListener_Touch(action As Int, X As Float, Y As Float) As Boolean";
 //BA.debugLineNum = 97;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 //BA.debugLineNum = 99;BA.debugLine="time0 = DateTime.Now";
_time0 = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 100;BA.debugLine="tOverPanel = Sender";
mostCurrent._toverpanel.setObject((android.view.ViewGroup)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 101;BA.debugLine="currentSlide=tOverPanel.Tag";
_currentslide = (int)(BA.ObjectToNumber(mostCurrent._toverpanel.getTag()));
 //BA.debugLineNum = 102;BA.debugLine="startX(currentslide) = X";
_startx[_currentslide] = (int)(_x);
 //BA.debugLineNum = 103;BA.debugLine="startY(currentslide) = Y";
_starty[_currentslide] = (int)(_y);
 //BA.debugLineNum = 104;BA.debugLine="tMainPanel = cMainPanel(CurrentSlide)";
mostCurrent._tmainpanel = mostCurrent._cmainpanel[_currentslide];
 break;
case 1:
 //BA.debugLineNum = 107;BA.debugLine="if x-startX(currentslide)>0 Then";
if (_x-_startx[_currentslide]>0) { 
 //BA.debugLineNum = 108;BA.debugLine="if tMainPanel.Left>=0 Then";
if (mostCurrent._tmainpanel.getLeft()>=0) { 
 //BA.debugLineNum = 109;BA.debugLine="tMainPanel.Left=0";
mostCurrent._tmainpanel.setLeft((int)(0));
 //BA.debugLineNum = 110;BA.debugLine="leftmargin(currentslide)=0";
_leftmargin[_currentslide] = (int)(0);
 //BA.debugLineNum = 111;BA.debugLine="Return";
if (true) return false;
 };
 }else {
 //BA.debugLineNum = 114;BA.debugLine="if leftmargin(currentslide)<= -tMainPanel.Width+tOverPanel.Width Then";
if (_leftmargin[_currentslide]<=-mostCurrent._tmainpanel.getWidth()+mostCurrent._toverpanel.getWidth()) { 
 //BA.debugLineNum = 115;BA.debugLine="leftmargin(currentslide) = -tMainPanel.Width+tOverPanel.Width";
_leftmargin[_currentslide] = (int)(-mostCurrent._tmainpanel.getWidth()+mostCurrent._toverpanel.getWidth());
 //BA.debugLineNum = 116;BA.debugLine="tMainPanel.Left=leftmargin(currentslide)";
mostCurrent._tmainpanel.setLeft(_leftmargin[_currentslide]);
 //BA.debugLineNum = 117;BA.debugLine="Return";
if (true) return false;
 };
 };
 //BA.debugLineNum = 120;BA.debugLine="if Abs(x-startX(currentslide))>10 Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_x-_startx[_currentslide])>10) { 
 //BA.debugLineNum = 121;BA.debugLine="MovePanel(x)";
_movepanel(_x);
 };
 break;
case 2:
 //BA.debugLineNum = 125;BA.debugLine="leftmargin(currentslide) = leftmargin(currentslide) + x-startX(currentslide)";
_leftmargin[_currentslide] = (int)(_leftmargin[_currentslide]+_x-_startx[_currentslide]);
 //BA.debugLineNum = 127;BA.debugLine="if Abs(x-startx(currentSlide))<10 Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_x-_startx[_currentslide])<10) { 
 //BA.debugLineNum = 128;BA.debugLine="choosed(x)";
_choosed((int)(_x));
 //BA.debugLineNum = 129;BA.debugLine="Return";
if (true) return false;
 };
 //BA.debugLineNum = 132;BA.debugLine="if DateTime.Now-time0<200 Then";
if (anywheresoftware.b4a.keywords.Common.DateTime.getNow()-_time0<200) { 
 //BA.debugLineNum = 133;BA.debugLine="if x-startX(currentslide)>0 Then";
if (_x-_startx[_currentslide]>0) { 
 //BA.debugLineNum = 134;BA.debugLine="sdR(currentSlide).Start(tmainPanel)";
mostCurrent._sdr[_currentslide].Start((android.view.View)(mostCurrent._tmainpanel.getObject()));
 }else {
 //BA.debugLineNum = 136;BA.debugLine="sdl(currentSlide).Start(tmainPanel)";
mostCurrent._sdl[_currentslide].Start((android.view.View)(mostCurrent._tmainpanel.getObject()));
 };
 };
 break;
}
;
 //BA.debugLineNum = 140;BA.debugLine="End Sub";
return false;
}
}
